



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java I/O 总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java I/O 总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 23:37:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Java I/O的的架构使用了装饰器的模式，我们在使用流的时候需要新建很多的装饰器对象，对源数据进行层层包装。各个包装类名以及它们的应用场景比较多，初学的时候难以摸清规律，这里我把它们归一下类，方便大家记忆。</p>
<h2>InputStream &amp; OutputStream</h2>
<hr />
<p><code>InputStream</code> 与 <code>OuputStream</code>是 Java 中 I/O 操作中最基本的类。</p>
<h3>InputStream</h3>
<p>先上类图：</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1851512-62945beca3f03e11.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>类图中的类大致可以分为三个部分。</p>
<ol><li>接口, 它包括了所有InputStream的基本操作。</li>
<li>源, 直接与各种形式的数据源直接打交道的类。对于某种特定形式的数据源，需要一种指定的InputStream来读取数据。图中几种常用的InputSream数据源类型的接口包括：<br />
<code>ByteArrayInputStream</code>, <code>StringBufferInputStream</code>, <code>FileInputStream</code>, <code>PipedInputStream</code>, <code>SequenceInputStream</code>。他们的构造参数各不相同，对应的数据源也各不相同。</li>
<li>格式, 如果直接使用‘源’类型的InputStream是可以直接读取数据的, 但是读取出来的数据的类型都是byte并且没有缓存, 大部分情况下需要我们转换成其它基本类型的数据。Java 为了方便我们读取其它类型的数据提供了几种类型的装饰器。常用的几种装饰器有 <code>DataInputStream</code>, <code>BufferedInputStream</code>。其中<code>DataInputStream</code>允许我们读取其它基本类型数据, <code>BufferedInputStream</code>使用了缓存，可以提高读取的效率。</li></ol>
<h3>OuputStream</h3>
<p>类图：<br />
<img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1851512-53415221db06a68c.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>与InputStream类似, 它也可以分为三部分：</p>
<ol><li>接口, 定义OutputStream的所有操作</li>
<li>目标, 这同数据源类似, 它决定了数据最终被写到哪里。它们都继承自FilterOutputStream。常用的几种形式有：<code>ByteArrayOutputStream</code>, <code>FileOutputStream</code>, <code>PipedOutputStream</code>。它们分别将数据写入到内存区域，文件，管道中。</li>
<li>形式, 默认的输出全部都是以Byte的形式写入到目标中的。如果想要写入其它一些基本类型的数据或者使用缓存提高效率，可以使用其它的装饰器包裹目标的OutputStream。常用的OutputStream装饰器有<code>DataOutputStream</code>, <code>PrintStream</code>, <code>BufferedOuputStream</code>, 他们的功能分别是写入基本类型, 写入换行符并清空缓存，提供了写入的目标的缓存。</li></ol>
<h2>Reader &amp; Writer</h2>
<hr />
<p><code>InputStream</code> &amp; <code>OutputStream</code> 的重要缺陷在于不能支持Unicode。所以，Java 1.1版本中，Java I/O库中添加了这两个重要的类专门用来处理字符读写。</p>
<h3>Reader</h3>
<p>类图：<br />
<img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1851512-2cae8a24261cedc9.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<p>与<code>InputStream</code>的架构类似，某些继承的顺序可能略有不同。</p>
<ol><li>接口 ,与<code>InputStream</code>的操作是类似的, 只是<code>Reader</code>是针对字符的。</li>
<li>源, 与<code>InputStream</code>相比多了一个<code>InputStreamReader</code>, 它可以从一个<code>InputStream</code>构造一个<code>Reader</code>。</li>
<li>格式， 与<code>InputStream</code>的读入格式类似，多了可以读入字符床的操作。</li></ol>
<h3>Writer</h3>
<p>类图：<br />
<img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1851512-15c8bb0b027a96a9.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<ol><li>接口，与<code>OuputStream</code>类似，针对字符，多了<code>append</code>操作</li>
<li>目标，多了<code>OutputStreamWriter</code>，允许我们通过<code>OutputStream</code>构造<code>Writer</code>。</li>
<li>格式，与Reader的格式对应，操作字符数据。</li></ol>
<h2>RandomAccessFile</h2>
<hr />
<p><code>RandomAccessFile</code>是一个独立的类与I/O,R/W 无关。它相当于把<code>InputStream</code>与<code>OutputStream</code>结合起来使用。并添加了一些位置相关的新操作。</p>
<p>类图：<br />
<img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/1851512-f2929fb2d62fffbe.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qngwx8r.html">字符型图片验证码识别完整过程及Python实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lj397.html">Oracle AWR报告提取方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27e2l8.html">CSS布局属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04km4q.html">JavaScript 的 OOP 功能解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ek569.html">foreach as 和 in&lowbar;array</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj26dk8.html">origin从图中获得数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y6xmg8.html">javascript设计模式&mdash;&mdash;代理模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zw67e9.html">JavaScript之优化DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpvp5xq.html">HDU 6107 Typesetting</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zxrye9.html">爬虫高性能 asyncio库 twisted库 tornado库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpg63q.html">汇编语言--微机CPU的指令系统（五）（标志位操作指令）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r20n68.html">Python向来以慢著称，为啥Instagram却唯独钟爱它？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllggleq.html">python 面向对象编程 之  反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4d5rj9.html">rails gem更换ruby-china源</a>
		</li>
						<li><a href="https://www.batexi.com/a/963dewn9.html">netsh 第一次用这命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gprxje9.html">控制台报错： SCRIPT1006&colon; Expected &amp;&num;39&semi;&rpar;&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p4l208.html">hibernate&lowbar;boolean类型的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvelp6x9.html">python执行linux和window的命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ve466q.html">Java：终结器防卫者，顺便看一下 C&num; 如何做的。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwok67k9.html">【codeforces-482div2-C】Kuro and Walking Route&lpar;DFS&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jn33v8.html">WPF文本框只允许输入数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdy2479.html">Flex中的FusionCharts 3D饼图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kplr779.html">R语言︱数据分组统计函数族&mdash;&mdash;apply族用法与心得</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge0xz08.html">PL&sol;SQL 基础知识简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkrrlj8.html">Django学习-19-缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z25y09.html">iOS - Quartz 2D 二维绘图</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ylrwn8.html">java实现组合问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkrj0e8.html">C&num;图解教程 第二十四章 反射和特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg3lym8.html">JAVA简单的网格布局管理器--JAVA基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkerj8.html">python操作excel常用的方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
